.586
.model flat,stdcall
option casemap:none

WinMain	PROTO	:DWORD,:DWORD,:DWORD,:DWORD

include \masm32\include\windows.inc
include \masm32\include\kernel32.inc
include \masm32\include\comctl32.inc
include \masm32\include\user32.inc

includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\comctl32.lib
includelib \masm32\lib\user32.lib
 
.const

MainWindowWidth	equ		600
MainWindowHeight	equ		400

WS_EDIT		equ		WS_VISIBLE+WS_CHILD+ES_MULTILINE+ES_WANTRETURN
.data
hInstance		dd			?
hMainWindow	dd			?
MainWindowClass	db		'MainWindowClass',0
MainWindowName	db		'Main Window',0
wcx			WNDCLASSEX		<sizeof wcx,CS_HREDRAW+CS_VREDRAW,offset WndProc,NULL,NULL,?,?,?,COLOR_WINDOW,NULL,\
							offset MainWindowClass,?>
;++++ Edit related ++++

szRichEditLib	db		'riched20.dll',0
EditClass		db		'RichEdit20a',0
hEdit1		dd		?
hEdit2		dd		?
EdStream	EDITSTREAM		<>

; ++++ Other Vars ++++

rect		RECT		<>
szFile	db		'.\File.txt',0
hFile		dd		?

.code
	start:
		invoke	GetModuleHandle,NULL
		mov		hInstance,eax
		invoke	WinMain,hInstance,NULL,NULL,SW_SHOWNORMAL
		invoke	ExitProcess,eax
		
WinMain	PROC	hInst:DWORD,hPInst:DWORD,CmdLine:DWORD,CmdShow:DWORD

	local	msg:MSG
	
	push		hInst
	pop		wcx.hInstance
	invoke	LoadIcon,NULL,IDI_APPLICATION
	mov		wcx.hIcon,eax
	mov		wcx.hIconSm,eax
	invoke	LoadCursor,NULL,IDC_ARROW
	mov		wcx.hCursor,eax
	invoke	RegisterClassEx,addr wcx
	invoke	GetSystemMetrics,SM_CYSCREEN
	shr		eax,1
	sub		eax,MainWindowHeight/2
	push		eax
	invoke	GetSystemMetrics,SM_CXSCREEN
	shr		eax,1
	sub		eax,MainWindowWidth/2
	pop		ebx
	invoke	CreateWindowEx,NULL,addr MainWindowClass,addr MainWindowName,WS_TILED,\
				eax,ebx,MainWindowWidth,MainWindowHeight,NULL,NULL,hInst,NULL
	mov		hMainWindow,eax
	invoke	ShowWindow,eax,CmdShow
	invoke	UpdateWindow,hMainWindow
	
msg_loop:
	invoke	GetMessage,addr msg,NULL,0,0
	or		eax,eax
	jz		end_msg_loop
	invoke	TranslateMessage,addr msg
	invoke	DispatchMessage,addr msg
	jmp		msg_loop
end_msg_loop:
	mov		eax,msg.wParam												
	Ret
WinMain EndP		
							
WndProc		PROC		hWnd:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD

	.if	uMsg==WM_DESTROY
		invoke	PostQuitMessage,NULL
	.elseif uMsg==WM_CREATE
		mov		edi,lParam
		.if		[edi.CREATESTRUCT].hWndParent==NULL
			invoke	LoadLibrary,addr szRichEditLib
			invoke	InitCommonControls
			invoke	GetClientRect,hWnd,addr rect
			shr		rect.bottom,1
			sub		rect.bottom,1
			invoke	CreateWindowEx,WS_EX_STATICEDGE,addr EditClass,NULL,WS_EDIT,\
						0,0,rect.right,rect.bottom,hWnd,NULL,hInstance,NULL
			mov		hEdit1,eax
			push		rect.bottom
			pop		rect.top
			add		rect.top,2
			invoke	CreateWindowEx,WS_EX_STATICEDGE,addr EditClass,NULL,WS_EDIT,\
						0,rect.top,rect.right,rect.bottom,hWnd,NULL,hInstance,NULL
			mov		hEdit2,eax
			invoke	SendMessage,hEdit1,EM_SETEVENTMASK,NULL,ENM_CHANGE
		.endif															
	.elseif 	uMsg==WM_COMMAND
		mov		eax,wParam
		ror		eax,16
		.if		ax==EN_CHANGE
			invoke	Beep,200,20
			push		hFile
			pop		EdStream.dwCookie
			mov		EdStream.pfnCallback,offset StreamOutProc
			invoke	SendMessage,hEdit1,EM_STREAMOUT,SF_TEXT,addr EdStream
			mov		EdStream.pfnCallback,offset StreamInProc
			invoke	SendMessage,hEdit2,EM_STREAMIN,SF_TEXT,addr EdStream
		.endif			

	.else
		invoke	DefWindowProc,hWnd,uMsg,wParam,lParam
		ret
	.endif
	xor		eax,eax					
	Ret
WndProc EndP		
				
StreamOutProc	PROC	dwCookie:DWORD,lpBuff:DWORD,cb:DWORD,pcb:DWORD

      invoke	CreateFile,addr szFile,GENERIC_WRITE,FILE_SHARE_READ+FILE_SHARE_WRITE+FILE_SHARE_DELETE,NULL,\
	               	OPEN_ALWAYS,FILE_ATTRIBUTE_NORMAL,NULL
        mov     hFile,eax
	invoke	WriteFile,hFile,lpBuff,cb,pcb,NULL
        invoke  CloseHandle,hFile
	xor		eax,FALSE
	ret
	
StreamOutProc EndP

StreamInProc		PROC	dwCookie:DWORD,lpBuff:DWORD,cb:DWORD,pcb:DWORD

	invoke	CreateFile,addr szFile,GENERIC_READ,FILE_SHARE_READ+FILE_SHARE_WRITE+FILE_SHARE_DELETE,NULL,\
            		OPEN_ALWAYS,FILE_ATTRIBUTE_NORMAL,NULL
    mov     hFile,eax            
	invoke	ReadFile,hFile,lpBuff,cb,pcb,NULL
    invoke  CloseHandle,hFile
	xor		eax,FALSE
	Ret
	
StreamInProc EndP
end		start								